
%Weights adjustment for a hidden neuron

function w_adj = HidNeurBack_weightadj(X, w, lamb, outneur_weights, phase_d, znet_d, y_d, sec_size, outneur_num, local_thresh)

%X = matrix of hidden neuron inputs (N x n+1), where N=number of learning
%samples, n = number of input variables
%w = (n+1 x 1) vector of weights of the hidden neuron
%delta = (N x 1) vector of errors

n_neur = size(w,2); % numero neuroni
ning = size(X, 2);  % numero ingressi
w_adj = w;
N = size(X, 1);

rperm = randperm(N);
X = X(rperm,:);
phase_d = phase_d(rperm,:);
znet_d = znet_d(rperm,:);
y_d = y_d(rperm,:);

for ns = 1:N
    
    %Compute the output of hidden neurons for sample ns
    hid_outmat = X(ns,:) * w;
        
    % Calculation the absolute values of the
    % current hidden neurons weighted sums
    abs_hid_outmat = abs(hid_outmat);
        
    %Move outputs to the unit circle
    hid_outmat = hid_outmat ./ abs_hid_outmat;
    
    [delta] = ErrBackProp_1s(hid_outmat, outneur_weights, phase_d(ns,:), znet_d(ns,:), y_d(ns,:), sec_size, N, n_neur, outneur_num, local_thresh, abs_hid_outmat);

    
    for nn = 1 : n_neur    
        for ni = 1:ning
            dd = (1/X(ns,ni))*delta(1,nn)/(ning+1);
            w_adj(ni,nn) = w_adj(ni,nn) + dd*lamb;
        end
    end
end
